import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { DealerOrder, DealerOrderParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询分销商订单记录表
 */
export async function pageDealerOrder(params: DealerOrderParam) {
  const res = await request.get<ApiResult<PageResult<DealerOrder>>>(
    MODULES_API_URL + '/shop/dealer-order/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询分销商订单记录表列表
 */
export async function listDealerOrder(params?: DealerOrderParam) {
  const res = await request.get<ApiResult<DealerOrder[]>>(
    MODULES_API_URL + '/shop/dealer-order',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加分销商订单记录表
 */
export async function addDealerOrder(data: DealerOrder) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/dealer-order',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改分销商订单记录表
 */
export async function updateDealerOrder(data: DealerOrder) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/dealer-order',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除分销商订单记录表
 */
export async function removeDealerOrder(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/dealer-order/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除分销商订单记录表
 */
export async function removeBatchDealerOrder(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/dealer-order/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询分销商订单记录表
 */
export async function getDealerOrder(id: number) {
  const res = await request.get<ApiResult<DealerOrder>>(
    MODULES_API_URL + '/shop/dealer-order/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
